/***************************************************************************
 *   Copyright (C) 2004 by Nicolas Brodu                                   *
 *   nicolas.brodu@free.fr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ATTITUDECORRECTION_H
#define ATTITUDECORRECTION_H

#include <osg/Quat>
#include <osg/Vec3d>

/**

    Specify how to update the old attitude to a new one, given the old and new
    directions. The problem comes from the fact infinitely many rotations
    can map the direction vectors, and we must choose only one.

    @author Nicolas Brodu
*/
class AttitudeCorrection {
public:
    AttitudeCorrection();

    virtual ~AttitudeCorrection();

    virtual void updateAttitude(osg::Quat &newAttitude, const osg::Quat &oldAttitude, const osg::Vec3d &newForward, const osg::Vec3d &oldForward) = 0;
};

#endif
