/***************************************************************************
 *   Copyright (C) 2004 by Nicolas Brodu                                   *
 *   nicolas.brodu@free.fr                                                 *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BILLBOARDOBSTACLE_H
#define BILLBOARDOBSTACLE_H

#include <osg/Texture2D>

#include "Obstacle.h"

/** An obstacle using a billboard and texture for its avatar.
Useful for creating trees, etc...


@author Nicolas Brodu
*/
class BillboardObstacle : public Obstacle
{
public:
    BillboardObstacle(const osg::Vec3d& pos, osg::Texture2D *texture, double width = 1.0, double height = 1.0);
    BillboardObstacle(const double& x, const double& y, const double& z, osg::Texture2D *texture, double width = 1.0, double height = 1.0);

protected:

    /** Build this agent avatar using the billboard technique with the given texture
    */
    virtual osg::Node* buildAvatar();
    
    osg::Texture2D *texture;
    double width,height;
};

#endif
