#!/bin/sh

if [ -z "$1" ]
then
    echo "Usage: $0 dir_name [filterComments]"
    echo "Use this script to run all the tools on a directory content"
    echo "Use an argument like 'true' to filter out comments"
    exit 0
fi

TARGETDIR=$1

THISDIR=`dirname $0`
if [ ! -z "$THISDIR" ] 
then
    THISDIR="$THISDIR/"
fi

if [ -z "$2" ]
then
    ${THISDIR}cycleCount.pl 80 $TARGETDIR/populations*
    ${THISDIR}generationCount.pl $TARGETDIR/statistics*
    ${THISDIR}timesCount.pl $TARGETDIR/transientTimes*
    ${THISDIR}turnoverRatios.pl $TARGETDIR/statistics*
    ${THISDIR}specialization.pl $TARGETDIR/genomes*
else
    ${THISDIR}cycleCount.pl 80 $TARGETDIR/populations*  | grep -v '#'
    ${THISDIR}generationCount.pl $TARGETDIR/statistics* | grep -v '#'
    ${THISDIR}timesCount.pl $TARGETDIR/transientTimes* | grep -v '#'
    ${THISDIR}turnoverRatios.pl $TARGETDIR/statistics* | grep -v '#'
    ${THISDIR}specialization.pl $TARGETDIR/genomes* | grep -v '#'
fi

